{ pkgs, ... }:

with builtins;
{
  config.my.programs.nvim.plugins = with pkgs.vimPlugins; [
    {
      plugin = which-key-nvim;
      conf = readFile ./which-key-nvim.lua;
    }
    {
      plugin = catppuccin-nvim;
      conf = readFile ./catppuccin-nvim.lua;
      priority = 99;
    }
    {
      plugin = formatter-nvim;
      lazy = true;
      keys = [
        { key = "="; cmd = "<cmd>Format<cr>"; desc = "format (formatter)"; }
      ];
      conf = readFile ./formatter-nvim.lua;
      dependencies = [{ plugin = which-key-nvim; lazy = true; }];
    }
    {
      plugin = oil-nvim;
      conf = readFile ./oil-nvim.lua;
      dependencies = [
        { plugin = which-key-nvim; lazy = true; }
        { plugin = nvim-web-devicons; lazy = true; }
      ];
    }
    {
      plugin = mini-nvim;
      conf = readFile ./mini-nvim.lua;
    }
    {
      plugin = noice-nvim;
      conf = readFile ./noice-nvim.lua;
      dependencies = [{ plugin = nui-nvim; lazy = true; }];
    }
    {
      plugin = trouble-nvim;
      lazy = true;
      keys = [
        { key = "<leader>xx"; cmd = "<cmd>TroubleToggle document_diagnostics<cr>"; desc = "Document Diagnostics (Trouble)"; }
        { key = "<leader>xX"; cmd = "<cmd>TroubleToggle workspace_diagnostics<cr>"; desc = "Workspace Diagnostics (Troule)"; }
        { key = "<leader>xl"; cmd = "<cmd>TroubleToggle loclist<cr>"; desc = "Location List (Trouble)"; }
        { key = "<leader>xq"; cmd = "<cmd>TroubleToggle quickfix<cr>"; desc = "Quickfix List (Trouble)"; }
        { key = "<leader>xt"; cmd = "<cmd>TodoTrouble<cr>"; desc = "Todo (Trouble)"; }
        { key = "<leader>xT"; cmd = "<cmd>TodoTrouble keywords=TODO,FIX,FIXME<cr>"; desc = "Todo/Fix/Fixme (Trouble)"; }
        { key = "<leader>st"; cmd = "<cmd>TodoTelescope<cr>"; desc = "Todo"; }
        {
          key = "[q";
          func = ''function()
        if require("trouble").is_open() then
          require("trouble").previous({ skip_groups = true, jump = true })
        else
          vim.cmd.cprev()
        end
      end'';
          desc = "Previous trouble/quickfix item";
        }
        {
          key = "]q";
          func = ''function()
        if require("trouble").is_open() then
          require("trouble").next({ skip_groups = true, jump = true })
        else
          vim.cmd.cnext()
        end
      end'';
          desc = "Next trouble/quickfix item";
        }
      ];
      conf = readFile ./trouble-nvim.lua;
      dependencies = [
        { plugin = which-key-nvim; }
        { plugin = nvim-web-devicons; lazy = true; }
      ];
    }
    {
      plugin = nvim-cmp;
      conf = readFile ./nvim-cmp.lua;
      lazy = true;
      event = [ "InsertEnter" ];
      dependencies = [
        { plugin = cmp-async-path; }
        { plugin = cmp-nvim-lsp; }
        { plugin = cmp_luasnip; }
        {
          plugin = copilot-cmp;
          dependencies = [
            {
              plugin = copilot-lua;
              conf = readFile ./copilot-lua.lua;
              dependencies = [{ plugin = which-key-nvim; }];
            }
          ];
        }
        { plugin = friendly-snippets; }
        { plugin = luasnip; lazy = true; }
      ];
    }
    {
      plugin = todo-comments-nvim;
      lazy = true;
      event = [ "BufReadPost" "BufNewFile" ];
      conf = readFile ./todo-comments-nvim.lua;
      dependencies = [{ plugin = plenary-nvim; lazy = true; }];
    }
    {
      plugin = direnv-vim;
    }
    {
      plugin = nvim-treesitter.withAllGrammars;
      lazy = true;
      event = [ "BufReadPost" "BufNewFile" ];
      conf = readFile ./nvim-treesitter.lua;
      dependencies = [
        {
          plugin = orgmode;
          lazy = true;
          conf = readFile ./orgmode.lua;
        }
      ];
    }
    {
      plugin = nvim-lspconfig;
      lazy = true;
      event = [ "BufReadPre" "BufNewFile" ];
      conf = readFile ./nvim-lspconfig.lua;
      dependencies = [
        {
          plugin = null-ls-nvim;
          lazy = true;
          conf = readFile ./null-ls-nvim.lua;
          dependencies = [
            { plugin = which-key-nvim; lazy = true; }
            { plugin = plenary-nvim; lazy = true; }
          ];
        }
        {
          plugin = which-key-nvim;
          lazy = true;
        }
        {
          plugin = lspkind-nvim;
          lazy = true;
        }
        {
          plugin = lsp_lines-nvim;
          lazy = true;
        }
        {
          plugin = lspsaga-nvim-original;
          lazy = true;
          dependencies = [
            { plugin = nvim-web-devicons; lazy = true; }
            { plugin = nvim-treesitter.withAllGrammars; lazy = true; }
          ];
        }
        {
          plugin = nvim-ufo;
          lazy = true;
          dependencies = [
            { plugin = promise-async; lazy = true; }
          ];
        }
      ];
    }
    {
      event = [ "VeryLazy" ];
      lazy = true;
      plugin = vim-fugitive;
    }
    {
      plugin = vim-tmux-navigator;
    }
    {
      plugin = gitsigns-nvim;
      lazy = true;
      event = [ "BufReadPost" "BufNewFile" ];
      conf = readFile ./gitsigns-nvim.lua;
      dependencies = [{ plugin = which-key-nvim; }];
    }
    {
      plugin = nvim-lastplace;
      lazy = true;
      event = [ "BufReadPost" "BufNewFile" ];
      conf = readFile ./nvim-lastplace.lua;
    }
    {
      plugin = nvim-treesitter-textsubjects;
      lazy = true;
      event = [ "BufReadPost" "BufNewFile" ];
      conf = readFile ./nvim-treesitter-textsubjects.lua;
      dependencies = [
        {
          plugin = nvim-treesitter.withAllGrammars;
          lazy = true;
        }
      ];
    }
    {
      plugin = nvim-ts-context-commentstring;
      lazy = true;
      event = [ "BufReadPost" "BufNewFile" ];
      conf = readFile ./nvim-ts-context-commentstring.lua;
      dependencies = [
        {
          plugin = nvim-treesitter.withAllGrammars;
          lazy = true;
        }
      ];
    }
    {
      plugin = smartcolumn-nvim;
      lazy = true;
      event = [ "BufReadPost" "BufNewFile" ];
      conf = readFile ./smartcolumn-nvim.lua;
    }
    {
      plugin = telescope-fzf-native-nvim;
      conf = readFile ./telescope-fzf-native-nvim.lua;
      lazy = true;
      keys = [
        { key = "<leader>ff"; cmd = "<cmd>Telescope find_files<cr>"; desc = "Find files"; }
        { key = "<leader>fb"; cmd = "<cmd>Telescope buffers<cr>"; desc = "Find buffers"; }
        { key = "<leader>fr"; cmd = "<cmd>Telescope oldfiles<cr>"; desc = "Find recent files"; }
        { key = "<leader>sl"; cmd = "<cmd>Telescope current_buffer_fuzzy_find<cr>"; desc = "Search lines"; }
        { key = "<leader>sg"; cmd = "<cmd>Telescope live_grep<cr>"; desc = "Live grep"; }
        { key = "<leader>sc"; cmd = "<cmd>Telescope command_history<cr>"; desc = "Command history"; }
        { key = "<leader>sC"; cmd = "<cmd>Telescope commands<cr>"; desc = "Commands"; }
        { key = "<leader>sd"; cmd = "<cmd>Telescope diagnostics<cr>"; desc = "Diagnostics"; }
        { key = "<leader>sh"; cmd = "<cmd>Telescope help_tags<cr>"; desc = "Help tags"; }
        { key = "<leader>sk"; cmd = "<cmd>Telescope keymaps<cr>"; desc = "Keymaps"; }
        { key = "<leader>ss"; cmd = "<cmd>Telescope lsp_document_symbols<cr>"; desc = "Symbols (Document)"; }
        { key = "<leader>sS"; cmd = "<cmd>Telescope lsp_workspace_symbols<cr>"; desc = "Symbols (Workspace)"; }
        { key = "<leader>gc"; cmd = "<cmd>Telescope git_commits<cr>"; desc = "Commits"; }
        { key = "<leader>gs"; cmd = "<cmd>Telescope git_status<cr>"; desc = "Status"; }
      ];
      dependencies = [
        {
          plugin = telescope-nvim;
          lazy = true;
          dependencies = [
            { plugin = plenary-nvim; lazy = true; }
            { plugin = which-key-nvim; lazy = true; }
          ];
        }
      ];
    }
  ];
}
